QGIS Application - Feature request #12298
Allow Oracle layers features to be simplified server-side before rendering
2015-03-02 08:32 AM - Michael Douchin

Status: Closed

Priority: Normal

Assignee: Jirgen Fischer

Category: Data Provider/Oracle

Pull Request or Patch supplied: Resolution: wontfix
Easy fix?: No Copied to github as #: 20476
Description

As for PostGreSQL, it would be nice to let Oracle simplify geometries when featching feature for rendering purpose. This would speed up
data retrival.

| have not found any suitable Oracle functions to mimic the 2 methods used for PostGreSQL provider : ST_SnapToGrid and
ST_SimplifyPreserveTopology. Perhaps it is not feasible ?

Thanks for any feedback.

History

#1 - 2015-03-02 08:47 AM - Jiirgen Fischer

SDO_UTIL.SIMPLIFY?

#2 - 2015-03-02 08:58 AM - Michael Douchin

Sure, could be. | am not sure if the PostGis "preservetopology" is needed, since we simplify at a pixel level...

#3 - 2015-03-02 08:59 AM - Michael Douchin

The tolerance parameter could be used to mimic the "snap to grid" function

#4 - 2015-03-06 09:40 AM - Michael Douchin

- File QGIS_oracle_pre_rendering_simplification.diff added

- Pull Request or Patch supplied changed from No to Yes

A patch attached with a first code running.

- | copy/paste what has been done in PostgreSQL provider, but since there is no equivalent for the functions used there, | used instead:

- SDO_UTIL.RECTIFY_GEOMETRY instead of ST_SnapToGrid, with the "tolerance" parameters used to snap to grid.
- SDO_UTIL.SIMPLIFY instead of ST_SimplifyPreserveTopology

- I have tested it with only one POLYGON layer, and got awkward results, which seems to be caused by simplification leading to POINT or LINESTRING
instead of original geometry type. Perhaps the problems lies also in incorrect geometries in my dataset

- | kept the tolerance used for PostGIS: mRequest.simplifyMethod().tolerance() * 0.8 There is surely a room for improvement here
http://docs.oracle.com/cd/B28359_01/appdev.111/b28400/sdo_util.htm#SPATL1246
http://docs.oracle.com/cd/B19306_01/appdev.102/b14255/sdo_util.htm#BJEICGGA
http://postgis.net/docs/ST_SnapToGrid.html
http://docs.oracle.com/cd/B19306_01/appdev.102/b14255/sdo_util.htm#BJEHCIBF
http://postgis.net/docs/ST_SimplifyPreserveTopology.html

- I do not know if the patch is suitable for both Oracle Locator and Oracle spatial

Please test the attached diff file and give feedback or advice

NB: This is the first time | work with Oracle. | invite Oracle Locator/Spatial gurus to participate, since | am a complete newbie here

NB2: You can use the docker/oracle here to set up a test environment.

#5 - 2015-03-09 05:39 AM - Michael Douchin

| need to to some benchmarking as described in #8725

#6 - 2016-08-02 10:08 AM - Médéric RIBREUX

- Resolution set to wontfix

- Status changed from Open to Closed

Hello,

| am closing this one because we have tried but it seems that simplifying from Oracle server just takes much more time than simply retrieving native

features.

Oracle database server doesn't seem to be able to simplify features with loading time improvment...

Files

QGIS_oracle_pre_rendering_simplification.diff 4.45 KB 2015-03-06 Michael Douchin
https://registry.hub.docker.com/u/alexeiled/docker-oracle-xe-11g/

